package de.hft.stuttgart.citydoctor2.gui.tree;

import java.text.DecimalFormat;
import java.text.DecimalFormatSymbols;

import de.hft.stuttgart.citydoctor2.datastructure.Edge;
import de.hft.stuttgart.citydoctor2.datastructure.Vertex;
import de.hft.stuttgart.citydoctor2.gui.Renderer;

public class EdgeNode extends Renderable {
	
	private static DecimalFormat nf;
	
	static {
		DecimalFormatSymbols dfs = DecimalFormatSymbols.getInstance();
		dfs.setDecimalSeparator('.');
		nf = new DecimalFormat("#.####", dfs);
	}
	
	private static final String SEPERATOR = ", ";
	private Edge e;
	private String text;
	
	public EdgeNode(Edge e) {
		this.e = e;
	}

	@Override
	public void refreshTextColor() {
		// not used
	}

	@Override
	public String getText() {
		if (text == null) {
			StringBuilder sb = new StringBuilder();
			sb.append("Edge from [");
			Vertex from = e.getFrom();
			sb.append(nf.format(from.getX()));
			sb.append(SEPERATOR);
			sb.append(nf.format(from.getY()));
			sb.append(SEPERATOR);
			sb.append(nf.format(from.getZ()));
			sb.append("] to [");
			Vertex to = e.getTo();
			sb.append(nf.format(to.getX()));
			sb.append(SEPERATOR);
			sb.append(nf.format(to.getY()));
			sb.append(SEPERATOR);
			sb.append(nf.format(to.getZ()));
			sb.append("]");
			text = sb.toString();
		}
		return text;
	}

	@Override
	public void visit(Renderer renderer) {
		renderer.highlight(e);
	}

}
