package de.hft.stuttgart.citydoctor2.gui.tree;

import de.hft.stuttgart.citydoctor2.datastructure.LinearRing;
import de.hft.stuttgart.citydoctor2.gui.CheckStatus;
import de.hft.stuttgart.citydoctor2.gui.Renderer;

public class LinearRingNode extends Renderable {

	private LinearRing lr;
	private String text;

	public LinearRingNode(LinearRing lr, CheckStatus cs) {
		this.lr = lr;
		setStatus(cs);
	}

	@Override
	public void refreshTextColor() {
		if (!lr.isValidated()) {
			setStatus(CheckStatus.NOT_CHECKED);
		} else if (lr.containsAnyError()) {
			setStatus(CheckStatus.ERROR);
		} else {
			setStatus(CheckStatus.OK);
		}
	}

	@Override
	public String getText() {
		if (text == null) {
			text = "Linear Ring (" + lr.getType().toString() + ") " + lr.getGmlId().getGmlString();
		}
		return text;
	}

	@Override
	public void visit(Renderer renderer) {
		renderer.highlight(lr);
	}

}
